LIBRARY IEEE;

USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY decode3_8 IS
    PORT (
          entree2 : IN  STD_LOGIC;
          entree1 : IN  STD_LOGIC;
          entree0 : IN  STD_LOGIC;                    
          sortie7 : OUT STD_LOGIC;
          sortie6 : OUT STD_LOGIC;
          sortie5 : OUT STD_LOGIC;
          sortie4 : OUT STD_LOGIC;
          sortie3 : OUT STD_LOGIC;
          sortie2 : OUT STD_LOGIC;
          sortie1 : OUT STD_LOGIC;
          sortie0 : OUT STD_LOGIC
    );
END decode3_8;

ARCHITECTURE rtl OF decode3_8 IS

SIGNAL s_entree : STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL s_sortie : STD_LOGIC_VECTOR(7 DOWNTO 0);

BEGIN

s_entree <= entree2 & entree1 & entree0;

sortie7 <= s_sortie(7);
sortie6 <= s_sortie(6);
sortie5 <= s_sortie(5);
sortie4 <= s_sortie(4);
sortie3 <= s_sortie(3);
sortie2 <= s_sortie(2);
sortie1 <= s_sortie(1);
sortie0 <= s_sortie(0);

PROCESS (s_entree)
BEGIN
	CASE s_entree IS
		WHEN "000" =>
			s_sortie <= "00000001";
		WHEN "001" =>
			s_sortie <= "00000010";
		WHEN "010" =>
			s_sortie <= "00000100";
		WHEN "011" =>
			s_sortie <= "00001000";
		WHEN "100" =>
			s_sortie <= "00010000";
		WHEN "101" =>
			s_sortie <= "00100000";
		WHEN "110" =>
			s_sortie <= "01000000";
		WHEN OTHERS =>
			s_sortie <= "10000000";
	END CASE;
END PROCESS;

END;
