LIBRARY IEEE;

USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

ENTITY mux41 IS
    PORT (
          entree3 : IN  STD_LOGIC;
          entree2 : IN  STD_LOGIC;
          entree1 : IN  STD_LOGIC;
          entree0 : IN  STD_LOGIC;                    
          sel1    : IN  STD_LOGIC;
          sel0    : IN  STD_LOGIC;
          sortie  : OUT STD_LOGIC
    );
END mux41;

ARCHITECTURE rtl OF mux41 IS

SIGNAL s_sel : STD_LOGIC_VECTOR(1 DOWNTO 0);

BEGIN

s_sel <= sel1 & sel0;

PROCESS (s_sel, entree0, entree1, entree2, entree3)
BEGIN
	CASE s_sel IS
		WHEN "00" =>
			sortie <= entree0;
		WHEN "01" =>
			sortie <= entree1;
		WHEN "10" =>
			sortie <= entree2;
		WHEN OTHERS =>
			sortie <= entree3;
	END CASE;
END PROCESS;

END;
